Merge lp:~tangent-org/libmemcached/1.0-build/ Build: jenkins-Libmemcached-219
[awesomized/libmemcached] / bootstrap.sh
index b548686f03b0cf280ba22dda72fa1da5d93fe19b..fdc43f999d0024fc2b576ddf4a672631e84c8040 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/bash
 # 
-# Copyright (C) 2012 Brian Aker
+# Copyright (C) 2012-2013 Brian Aker
 # All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
 
 command_not_found_handle ()
 {
-  echo "Command not found: '$@'"
-  exit 127
+  warn "$@: command not found"
+
+  #if $DEBUG; then 
+    echo ""
+    echo "Stack trace:"
+    local frame=0
+    while caller $frame; do
+      ((frame++));
+    done
+    echo ""
+  #fi
+
+  return 127
+}
+
+function error ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
 }
 
 function die ()
@@ -55,6 +71,12 @@ function die ()
   exit 1; 
 }
 
+function warn ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@"
+  #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
+}
+
 function nassert ()
 {
   local param_name=\$"$1"
@@ -77,7 +99,7 @@ function assert ()
   fi
 }
 
-assert_file ()
+function assert_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -85,7 +107,7 @@ assert_file ()
   fi
 }
 
-assert_no_file ()
+function assert_no_file ()
 {
   if [ -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
@@ -93,7 +115,15 @@ assert_no_file ()
   fi
 }
 
-assert_exec_file ()
+function assert_no_directory ()
+{
+  if [ -d "$1" ]; then
+    echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
+    exit 1;
+  fi
+}
+
+function assert_exec_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -106,12 +136,12 @@ assert_exec_file ()
   fi
 }
 
-command_exists ()
+function command_exists ()
 {
   type "$1" &> /dev/null ;
 }
 
-rebuild_host_os ()
+function rebuild_host_os ()
 {
   HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
   if [ -z "$1" ]; then
@@ -122,7 +152,7 @@ rebuild_host_os ()
 }
 
 #  Valid values are: darwin,fedora,rhel,ubuntu
-set_VENDOR_DISTRIBUTION ()
+function set_VENDOR_DISTRIBUTION ()
 {
   local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
   case "$dist" in
@@ -147,7 +177,7 @@ set_VENDOR_DISTRIBUTION ()
   esac
 }
 
-set_VENDOR_RELEASE ()
+function set_VENDOR_RELEASE ()
 {
   local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
   case "$VENDOR_DISTRIBUTION" in
@@ -177,7 +207,7 @@ set_VENDOR_RELEASE ()
 
 
 #  Valid values are: apple, redhat, centos, canonical
-set_VENDOR ()
+function set_VENDOR ()
 {
   local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
 
@@ -206,7 +236,7 @@ set_VENDOR ()
   set_VENDOR_RELEASE $3
 }
 
-determine_target_platform ()
+function determine_target_platform ()
 {
   UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
   UNAME_KERNEL=`(uname -s) 2>/dev/null`  || UNAME_SYSTEM=unknown
@@ -242,7 +272,7 @@ determine_target_platform ()
   rebuild_host_os
 }
 
-run_configure ()
+function run_configure ()
 {
   # We will run autoreconf if we are required
   run_autoreconf_if_required
@@ -252,6 +282,10 @@ run_configure ()
     die "Programmer error, we entered run_configure with a stacked directory"
   fi
 
+  if ! command_exists "$CONFIGURE"; then
+    die "$CONFIGURE does not exist"
+  fi
+
   local BUILD_DIR="$1"
   if [[ -n "$BUILD_DIR" ]]; then
     rm -r -f $BUILD_DIR
@@ -260,40 +294,52 @@ run_configure ()
   fi
 
   # Arguments for configure
-  local CONFIGURE_ARG= 
+  local BUILD_CONFIGURE_ARG= 
 
   # Set ENV DEBUG in order to enable debugging
   if $DEBUG; then 
-    CONFIGURE_ARG='--enable-debug'
+    BUILD_CONFIGURE_ARG='--enable-debug'
   fi
 
   # Set ENV ASSERT in order to enable assert
   if [[ -n "$ASSERT" ]]; then 
     local ASSERT_ARG=
     ASSERT_ARG='--enable-assert'
-    CONFIGURE_ARG="$ASSERT_ARG $CONFIGURE_ARG"
+    BUILD_CONFIGURE_ARG="$ASSERT_ARG $BUILD_CONFIGURE_ARG"
+  fi
+
+  if [[ -n "$CONFIGURE_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG= "$BUILD_CONFIGURE_ARG $CONFIGURE_ARG"
   fi
 
+  ret=1;
   # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
   case $HOST_OS in
     *-darwin-*)
-      CC=clang CXX=clang++ $top_srcdir/configure $CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $CONFIGURE_ARG $PREFIX_ARG"
+      CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+      ret=$?
       ;;
     rhel-5*)
-      command_exists gcc44 || die "Could not locate gcc44"
-      CC=gcc44 CXX=gcc44 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $CONFIGURE_ARG $PREFIX_ARG"
+      command_exists 'gcc44' || die "Could not locate gcc44"
+      CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+      ret=$?
       ;;
     *)
-      $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute configure $CONFIGURE_ARG $PREFIX_ARG"
+      $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG
+      ret=$?
       ;;
   esac
 
+  if [ $ret -ne 0 ]; then
+    die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+  fi
+
   if [ ! -f 'Makefile' ]; then
-    die "Programmer error, configure was run but no Makefile existed afterward"
+    die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
   fi
 }
 
-setup_gdb_command () {
+function setup_gdb_command () {
   GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
   echo 'set logging overwrite on' > $GDB_TMPFILE
   echo 'set logging on' >> $GDB_TMPFILE
@@ -304,15 +350,80 @@ setup_gdb_command () {
   GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
 }
 
-setup_valgrind_command () {
+function setup_valgrind_command () {
   VALGRIND_PROGRAM=`type -p valgrind`
   if [[ -n "$VALGRIND_PROGRAM" ]]; then
     VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
   fi
 }
 
-push_PREFIX_ARG ()
+function save_BUILD ()
 {
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
+    die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$CONFIGURE" ]]; then
+    OLD_CONFIGURE=$CONFIGURE
+  fi
+
+  if [[ -n "$CONFIGURE_ARG" ]]; then
+    OLD_CONFIGURE_ARG=$CONFIGURE_ARG
+  fi
+
+  if [[ -n "$MAKE" ]]; then
+    OLD_MAKE=$MAKE
+  fi
+
+  if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+    OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
+  fi
+}
+
+function restore_BUILD ()
+{
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    CONFIGURE=$OLD_CONFIGURE
+  fi
+
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    CONFIGURE_ARG=$OLD_CONFIGURE_ARG
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    MAKE=$OLD_MAKE
+  fi
+
+  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
+    TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
+  fi
+
+  OLD_CONFIGURE=
+  OLD_CONFIGURE_ARG=
+  OLD_MAKE=
+  OLD_TESTS_ENVIRONMENT=
+
+  export -n CC CXX
+}
+
+function push_PREFIX_ARG ()
+{
+  if [[ -n "$OLD_PREFIX_ARG" ]]; then
+    die "OLD_PREFIX_ARG was set on push, programmer error!"
+  fi
+
   if [[ -n "$PREFIX_ARG" ]]; then
     OLD_PREFIX_ARG=$PREFIX_ARG
     PREFIX_ARG=
@@ -323,17 +434,17 @@ push_PREFIX_ARG ()
   fi
 }
 
-pop_PREFIX_ARG ()
+function pop_PREFIX_ARG ()
 {
   if [[ -n "$OLD_PREFIX_ARG" ]]; then
-    PREFIX_ARG=$OLD_TESTS_ENVIRONMENT
+    PREFIX_ARG=$OLD_PREFIX_ARG
     OLD_PREFIX_ARG=
   else
     PREFIX_ARG=
   fi
 }
 
-push_TESTS_ENVIRONMENT ()
+function push_TESTS_ENVIRONMENT ()
 {
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
     die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
@@ -345,7 +456,7 @@ push_TESTS_ENVIRONMENT ()
   fi
 }
 
-pop_TESTS_ENVIRONMENT ()
+function pop_TESTS_ENVIRONMENT ()
 {
   TESTS_ENVIRONMENT=
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
@@ -498,24 +609,166 @@ function make_for_snapshot ()
   snapshot_check
 }
 
-function make_for_mingw32 ()
+function check_mingw ()
+{
+  command_exists 'mingw64-configure'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  command_exists 'mingw64-make'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang ()
+{
+  command_exists 'clang'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang_analyzer ()
+{
+  command_exists 'scan-build'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function make_skeleton ()
+{
+  run_configure
+  ret=$?
+
+  if [ $ret -eq 0 ]; then
+    assert_file 'Makefile'
+
+    make_target 'all' 'warn'
+    ret=$?
+    if [ $ret -ne 0 ]; then
+      warn "$MAKE failed"
+    else
+      if [[ -n "$DISPLAY" ]]; then
+        if command_exists 'wine'; then
+          TESTS_ENVIRONMENT='wine'
+        fi
+      fi
+
+      if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+        make_target 'check' 'warn' || warn "$MAKE check failed"
+        ret=$?
+      fi
+    fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean' 'warn'
+    fi
+  fi
+
+  return $ret
+}
+
+function make_for_mingw ()
+{
+  if ! check_mingw; then
+    return 1
+  fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
+  fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CONFIGURE='mingw64-configure'
+  MAKE='mingw64-make'
+  CONFIGURE_ARGS='--enable-static --disable-shared'
+
+  make_skeleton
+  ret=$?
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang ()
 {
+  if ! check_clang; then
+    return 1
+  fi
+
   # Make sure it is clean
   if [ -f Makefile -o -f configure ]; then
     make_maintainer_clean
   fi
-  assert_no_file 'Makefile'
 
-  if command_exists mingw32-configure; then
-    run_autoreconf
+  run_autoreconf
 
-    mingw32-configure || die 'mingw32-configure failed'
-    assert_file 'Makefile'
+  save_BUILD
 
-    if command_exists mingw32-make; then
-      mingw32-make || die 'mingw32-make failed'
-    fi
+  CC=clang CXX=clang++
+  export CC CXX
+
+  make_skeleton
+  ret=$?
+
+  make_target 'check'
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang_analyzer ()
+{
+  if ! check_clang; then
+    return 1
+  fi
+
+  if ! check_clang_analyzer; then
+    die 'clang-analyzer was not found'
+  fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
   fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CC=clang CXX=clang++
+  export CC CXX
+  CONFIGURE_ARGS='--enable-debug'
+
+  make_skeleton
+  ret=$?
+
+  make_target 'clean' 'warn'
+
+  scan-build -o clang-html make -j4 -k
+
+  restore_BUILD
+
+  return $ret
 }
 
 # If we are locally testing, we should make sure the environment is setup correctly
@@ -540,7 +793,13 @@ function make_universe ()
   make_valgrind
   make_gdb
   make_rpm
-  make_for_mingw32
+  make_for_clang
+  make_for_clang_analyzer
+
+  if [ check_mingw -eq 0 ]; then
+    make_for_mingw
+  fi
+
   make_distcheck
   make_install_system
 }
@@ -631,11 +890,18 @@ function self_test ()
   eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
 }
 
-function make_gdb ()
+function make_install_html ()
 {
   run_configure_if_required
+  assert_file 'configure'
+
+  make_target 'install-html'
+}
 
-  if command_exists gdb; then
+function make_gdb ()
+{
+  if command_exists 'gdb'; then
+    run_configure_if_required
 
     push_TESTS_ENVIRONMENT
 
@@ -652,7 +918,7 @@ function make_gdb ()
       TESTS_ENVIRONMENT="$GDB_COMMAND"
     fi
 
-    make_target check
+    make_target 'check'
 
     if [ -f 'gdb.txt' ]; then
       rm 'gdb.txt'
@@ -663,6 +929,10 @@ function make_gdb ()
     if [ -f '.gdb_history' ]; then
       rm '.gdb_history'
     fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean'
+    fi
   else
     echo 'gdb was not present'
     return 1
@@ -692,11 +962,19 @@ function make_target ()
     die "MAKE was not set"
   fi
 
-  if [ -n "$2" ]; then
-    run $MAKE $1 || return 1
-  else
-    run $MAKE $1 || die "Cannot execute $MAKE $1"
+  # $2 represents error or warn
+  run $MAKE $1
+  ret=$?
+
+  if [ $ret -ne 0 ]; then
+    if [ -n "$2" ]; then
+      warn "Failed to execute $MAKE $1: $ret"
+    else
+      die "Failed to execute $MAKE $1: $ret"
+    fi
   fi
+
+  return $ret
 }
 
 function make_distcheck ()
@@ -706,9 +984,16 @@ function make_distcheck ()
 
 function make_rpm ()
 {
-  if [ -f 'rpm.am' -o -d 'rpm' ]; then
-    run_configure_if_required
-    make_target 'rpm'
+  if command_exists 'rpmbuild'; then
+    if [ -f 'rpm.am' -o -d 'rpm' ]; then
+      run_configure_if_required
+      make_target 'rpm'
+
+      if $jenkins_build_environment; then
+        make_target 'clean'
+      fi
+
+    fi
   fi
 }
 
@@ -716,6 +1001,11 @@ function make_maintainer_clean ()
 {
   run_configure_if_required
   make_target 'maintainer-clean' 'no_error'
+
+  # Lets make sure we really cleaned up the environment
+  assert_no_file 'Makefile'
+  assert_no_file 'configure'
+  assert_no_directory 'autom4te.cache'
 }
 
 function make_check ()
@@ -777,10 +1067,14 @@ function run ()
     echo "\`$@' $ARGS"
   fi
 
+  if [ -z "$1" ]; then
+    return 127;
+  fi
+
   eval $@ $ARGS
 } 
 
-parse_command_line_options ()
+function parse_command_line_options ()
 {
   local SHORTOPTS=':apcmt:dvh'
 
@@ -838,7 +1132,7 @@ parse_command_line_options ()
   fi
 }
 
-determine_vcs ()
+function determine_vcs ()
 {
   if [[ -d '.git' ]]; then
     VCS_CHECKOUT=git
@@ -868,10 +1162,10 @@ function autoreconf_setup ()
 {
   # Set ENV MAKE in order to override "make"
   if [[ -z "$MAKE" ]]; then 
-    if command_exists gmake; then
+    if command_exists 'gmake'; then
       MAKE=`type -p gmake`
     else
-      if command_exists make; then
+      if command_exists 'make'; then
         MAKE=`type -p make`
       fi
     fi
@@ -980,7 +1274,7 @@ function autoreconf_setup ()
   run $AUTORECONF '--help'  &> /dev/null    || die "Failed to run AUTORECONF:$AUTORECONF"
 }
 
-print_setup ()
+function print_setup ()
 {
   saved_debug_status=$DEBUG
   if $DEBUG; then
@@ -1059,7 +1353,7 @@ print_setup ()
   fi
 }
 
-make_clean_option ()
+function make_clean_option ()
 {
   run_configure_if_required
 
@@ -1072,7 +1366,7 @@ make_clean_option ()
   fi
 }
 
-make_for_autoreconf ()
+function make_for_autoreconf ()
 {
   if [ -f 'Makefile' ]; then
     make_maintainer_clean
@@ -1083,7 +1377,7 @@ make_for_autoreconf ()
   assert_no_file 'Makefile'
 }
 
-check_make_target()
+function check_make_target()
 {
   case $1 in
     'self')
@@ -1124,6 +1418,10 @@ check_make_target()
       ;;
     'make_default')
       ;;
+    'clang')
+      ;;
+    'clang-analyzer')
+      ;;
     'test-*')
       ;;
     'valgrind-*')
@@ -1190,6 +1488,9 @@ function bootstrap ()
       'gdb')
         make_gdb
         ;;
+      'install-html')
+        make_install_html
+        ;;
       'clean_op')
         make_clean_option
         ;;
@@ -1205,8 +1506,35 @@ function bootstrap ()
       'make_default')
         make_default
         ;;
+      'clang')
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang; then
+          die "Failed to build clang: $?"
+        fi
+        ;;
+      'clang-analyzer')
+        if ! check_clang_analyzer; then
+          die "clang-analyzer was not found"
+        fi
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang_analyzer; then
+          die "Failed to build clang-analyzer: $?"
+        fi
+        ;;
       'mingw')
-        make_for_mingw32
+        if ! check_mingw; then
+          die "mingw was not found"
+        fi
+
+        if ! make_for_mingw; then
+          die "Failed to build mingw: $?"
+        fi
         ;;
       'snapshot')
         make_for_snapshot
@@ -1231,13 +1559,14 @@ function bootstrap ()
   done
 }
 
-main ()
+function main ()
 {
   # Variables we export
   declare -x VCS_CHECKOUT=
 
   # Variables we control globally
   local MAKE_TARGET=
+  local CONFIGURE=
 
   # Options for getopt
   local AUTORECONF_OPTION=false
@@ -1249,12 +1578,23 @@ main ()
   local TARGET_OPTION_ARG=
   local VERBOSE_OPTION=false
 
+  local OLD_CONFIGURE=
+  local OLD_CONFIGURE_ARG=
+  local OLD_MAKE=
+  local OLD_TESTS_ENVIRONMENT=
+
   # If we call autoreconf on the platform or not
   local AUTORECONF_REBUILD_HOST=false
   local AUTORECONF_REBUILD=false
 
   local -r top_srcdir=`pwd`
 
+  # Default configure
+  if [ -z "$CONFIGURE" ]; then
+    CONFIGURE="$top_srcdir/configure"
+  fi
+
+
   # Variables for determine_target_platform () and rebuild_host_os ()
   #   UNAME_MACHINE_ARCH= uname -m
   #   VENDOR= apple, redhat, centos, canonical
@@ -1337,7 +1677,7 @@ function merge ()
   fi
 }
 
-enable_debug ()
+function enable_debug ()
 {
   if ! $DEBUG; then
     local caller_loc=`caller`
@@ -1363,7 +1703,7 @@ function usage ()
 EOF
 }
 
-disable_debug ()
+function disable_debug ()
 {
   set +x
   DEBUG=true